#!/usr/bin/perl -Tw

#-----------------------------------------------------------------------------#
#	readme / help

my $progHistory=<<'EOhistory';

	DNSSEC keys tester & roller
	DNSSEC keys u

$Id: rolling_keys.pl 02 2010/2/24 11:31:53 kanashimi $

HISTORY:
2009/10/24 11:3:18-28 0:0:26	main program by kanashimi
2010/2/24 11:00:29	}


:
 DNSSEC VӶV`ءAN~o{ۤveCX@k峹Ʀb Google jM "DNSSEC Howto" eTWAFjaKϥΡAgFoӤpuC
u㪺γ~۰ʱç(rolling) ZSK keyA󬰤wgۤvާ@L DNSSEC ]mAAϥ bind9AåBȦ@ ZSK key pC

** ФdU`NG
	1. ]uAΦbp̪WA]ϥήɫD`ݭn`NIo{OuAXAΪkOФjas{X]w覡ۤvʾާ@CMAzYO@Nիᴣ@IĳA۫HUhHK
	2. ϥΫeЪl user config ]wC

ĳШUCQװϵoG
https://meicho.com.tw/phpBB3/viewforum.php?f=9

main siite:
http://lyrics.meicho.com.tw/
location:
http://lyrics.meicho.com.tw/program/DNSSEC/rolling_keys.pl


TODO:
initial DNSSEC
roll KSK
get zone file from named config file


EOhistory
undef $progHistory;


# from BaseF.pm
#	for safer use
$ENV{PATH}='/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/bin';	#	prevent 'Insecure $ENV{PATH} while running with -T switch'
	#	/usr/local/sbinw
	#	/usr/local/sbin/httpd,/usr/local/sbin/apachectl,/usr/local/bin/apachectl
	#	can't set to '' ! because adduser need use cat and cut command.
delete @ENV{qw(TERM IFS CDPATH ENV BASH_ENV)};	#	Make %ENV safer: http://www.perldoc.com/perl5.004_05/pod/perlsec.html


use strict;	#	restrict unsafe constructs: variable must declare use
use warnings;


# SݨD
use Sys::Hostname;
use Net::DNS;
use Net::DNS::SEC;
use Time::Local;	#	timegm

#-----------------------------------------------------------------------------#
#	user config

my $debug=0;

# in seconds
my $timeout=1;

# for key rolling

# bind9 directory
my $named_directory = '/etc/namedb/';

# where the master zone files located
my $master_zone_directory = $named_directory.'master/';

# the DNSSEC working directory
my $DNSSEC_directory = $named_directory.'DNSSEC/';
# the directory to put DNSSEC key files
my $keys_directory = $DNSSEC_directory;

# the directory to put expired DNSSEC key files
my $expired_keys_directory = $DNSSEC_directory.'expired/';

# the directory that programs dnssec-keygen, dnssec-signzone, named-checkconf, and rndc located
my $program_directory = '/usr/sbin/';


# TODO: get zone file from named config file
#my $named_config_file = $named_directory.'named.conf';

#-----------------------------------------------------------------------------#
#	program config & setup

# The domain and its master server.
my $domain = shift(@ARGV) || hostname;

my $name_server;

my $authoritative_server = shift @ARGV;
my $authoritative_server_address;

#-----------------------------------------------------------------------------#
#	function

#use Net::DNS;

my $find_recode_resource_record_object = Net::DNS::Resolver->new();
my $find_recode_hostname;
my $find_recode_errorstring;
my $find_recode_query;

$find_recode_resource_record_object->tcp_timeout($timeout);
$find_recode_resource_record_object->udp_timeout($timeout);

sub find_recode{
 my ($recode, $host, $type, $limit, $func) = @_;

 $type = $recode if !$type;
 if(!$limit){
  $limit = 1 if $type eq 'A' || $type eq 'NS' || $type eq 'SOA';
 }

 if($host){
  $find_recode_hostname=$host;
 }else{
  $host=$find_recode_hostname;
 }

 print 'find_recode: Try to find '.($limit||'ALL')." [$host]'s ".($recode?$recode.' recode':'recode of last query')." with type: $type.\n" if $debug;

 # use last query when recode doesn't set.
 if($recode){
  $find_recode_query = $find_recode_resource_record_object->send($host, $recode);
  if (!$find_recode_query){
   warn 'Query failed: ', $find_recode_resource_record_object->errorstring if $debug;
   $find_recode_errorstring = $find_recode_resource_record_object->errorstring;
   return;
  }
 }

 if($type eq 'NS'){
  $func = sub{ return $_[0]->nsdname; };
 }elsif($type eq 'A'){
  $func = sub{ return $_[0]->address; };
 }

 my @answer;
 my $l=$limit;
 foreach my $rr ($type? grep { $_->type eq $type } $find_recode_query->answer: $find_recode_query->answer) {
  my $rec = $func?&{$func}($rr):$rr;
  if($debug){
   print 'find_recode: Find '.$rr->type.' recode: '
	#.(ref($rec)?'('.ref($rec).')':'')
	."$rec\n";
   print $rr->string if $debug>1;
   #print "find_recode: $func\n" if $debug;
  }
  push @answer, $rec;
  last if !--$l;
 }

 print 'find_recode: return answer: ['.scalar(@answer).($limit?'/'.$limit:'')."]\n	".join("\n	",@answer)."\n" if $debug;
 $find_recode_errorstring = '';
 return $limit==1? $answer[0]: @answer;
}

#-----------------------------------------------------------------------------#
#	main

if(!$authoritative_server){
 if ($name_server = find_recode('NS', $domain)){
  $authoritative_server = $name_server;
 }else{
  warn 'Query name authoritative server failed: ', $find_recode_errorstring;
 }
}
die "No authoritative server specified." if !$authoritative_server;

$authoritative_server_address = find_recode('A', $authoritative_server) || $authoritative_server;
if (!$authoritative_server_address){
 warn "Can't found address of authoritative server [$authoritative_server]: ", $find_recode_errorstring;
}

print "Test [$domain] authoritativing with name server [$authoritative_server] ($authoritative_server_address).\n";

# setup name server
$find_recode_hostname = $domain;
$find_recode_resource_record_object->nameserver( $authoritative_server_address || $authoritative_server );
$find_recode_resource_record_object->dnssec(1);

my %keyRR;
find_recode('DNSKEY',0,0,0,sub{
	my $rr = $_[0];
	print "## DNSKEY: ".$rr->keytag."\n" if $debug;
	$keyRR{$rr->keytag}=$rr;
	return $rr;
});
die "NO DNSKEYS found for [$domain]" unless scalar keys %keyRR;

my $SOA = find_recode('SOA');
die "NO SOA RR found" unless $SOA;

my @need_rolling;
my @SOAsig = find_recode(0,0,'RRSIG',0,sub{
	my $rr = $_[0];
	my $keytag = $rr->keytag;
	print "** SOA signature: $keytag.\n" if $debug;

	my $key_found = exists $keyRR{$keytag}?$keyRR{$keytag}:0;
	delete $keyRR{$keytag};	#	We'll need using keyRR to determine what is KSK.

	if(!$key_found){
	 warn "NO public key found to validate [$keytag]";
	}elsif(!$rr->verify([ $SOA ], $key_found)){	# validate the key	http://www.net-dns.org/docs/Net/DNS/RR/RRSIG.html
	 warn "Signature made with $keytag failed to verify:\n!! ".$rr->vrfyerrstr."\n";
	 push @need_rolling, $rr;
	}else{
	 # The signature validated.
	 $rr->sigexpiration =~ /(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})/;
	 my $expiration = timegm ($6, $5, $4, $3, $2-1, $1-1900);
	 my $hourstogo = ($expiration-time())/3600;
	 if($hourstogo<48){
	  push @need_rolling, $rr;
	  warn "WARNING: Signature made with ".$rr->tag."will expire within $hourstogo hours";
	 }else{
	  print "SOA signature $keytag is OK.\n";
	 }
	}

	return $rr;
});
die "NO RRSIGs over the SOA found" unless @SOAsig;
print 'All '.@need_rolling.'/'.@SOAsig." signatures need to roll.\n";





#-----------------------------------------------------------------------------#
#	rolling key part

exit if !scalar @need_rolling;

my $rolling_key = $need_rolling[0]->keytag;


print "\nDo you want roll the key [$rolling_key] NOW?\nInput 'Y' to roll key.\n";
exit if <>!~/^y$/i;


my $unsigned_zone_file = get_unsigned_zone_file($domain);

die "Can't found unsigned zone file of [$domain]!" if !$unsigned_zone_file;
die "Can't open unsigned zone file [$unsigned_zone_file]!" if !open ZONE_FILE, $unsigned_zone_file;
my $temporary_unsigned_zone_file = $unsigned_zone_file.'.tmp';
die "Can't open temp unsigned zone file [$temporary_unsigned_zone_file]!" if !open TEMP_ZONE_FILE, '>'.$temporary_unsigned_zone_file;

print "Zone file of [$domain]: [$unsigned_zone_file]\n" if $debug;


chdir $keys_directory;
chdir '/tmp' if $debug;

my $key_string = `${program_directory}dnssec-keygen -a RSASHA1 -b 1024 -n ZONE "$domain"`;	#	man dnssec-keygen
chomp $key_string;
$key_string =~/^K(.+)\+(\d+)\+(\d+)$/;
my $key_id = get_key_pattern($key_string);
$key_id = $key_id->{id} if $key_id;
die 'DNSSEC key generation failed!' if !$key_id;

print "Generate new key: $key_string\n";


# read-in zone file and write new zone file
my ($l,$KSK,$KSK_file,$include_pattern);

# now in what key zone
my $in_zone = 0;

#-------------------------------------#
#	functions for rolling key part

#-------------------------------------#
#	return time now
# from BaseF.pm
sub Now{
 #return ''.localtime(time);
 my ($sec,$min,$hour,$mday,$mon,$year,$wday) = (localtime(time))[0..6];
 return ($year+1900).'/'.($mon+1)."/$mday $hour:$min:$sec";	#	 print ɫeݭn[ ''.
}

#-------------------------------------#
#	remove taint.]-TAݰhMw]Cugly hack
# ҥHgL regular expressions NhMw]AO]{wo˴Nܤwg regular expressions ˬdLFC
# from BaseF.pm
sub rmTaint{
 if($#_>=0){return $1 if $_[0] && $_[0]=~/^([^\x00]*)$/s;}
 return '';
}



#-------------------------------------#
sub change_zone{
 print $_[0]?$_[0].' zone detected':'Get out of key zone', ".\n" if $debug;
 print '>> '.$l if $debug>1;
 if($in_zone eq 'ZSK'){
  if($include_pattern){
   print "Add key [$key_string].\n" if $debug;
   $include_pattern=~s/[^\/]+$//;
   print TEMP_ZONE_FILE '; '.Now()." auto adding by $0\n".$include_pattern.$key_string.".key\n";
  }else{
   warn "Didn't found \$include pattern. Can't add ZSK key!";
  }
 }
 $in_zone = $_[0];
}

#-------------------------------------#
# find specified zone file
sub get_unsigned_zone_file{
 my $zone = $_[0];
 my $f = $master_zone_directory.$zone.'.hosts';
 return $f if -f $f;
}


sub get_key_pattern{
 print "get_key_pattern: parse [$_[0]]\n" if $debug>1;
 $_[0]=~/([^\/]+)$/;
 my $pattern = $1;
 #	man dnssec-keygen	(key name, numeric representation of the algorithm, key identifier)
 return {name=>$1,algorithm=>$2,id=>$3,extension=>$5} if $pattern=~/^K(.+)\.\+(\d+)\+(\d+)(\.(key|private))?$/;
}


sub move_expired{
 my $rolling_key = $_[0];
 if(!opendir DIR, $keys_directory){
  print "Can't open keys directory [$keys_directory]!\n";
  return;
 }
 my $p;
 my @key_files = grep { ($p = get_key_pattern($_)) && $p->{id} == $rolling_key } readdir (DIR);
 closedir DIR;
 print 'move_expired: ', scalar(@key_files), " files match key [$rolling_key].\n" if $debug;
 for $p (@key_files){
  print "move [$p] to [$expired_keys_directory$p]\n" if $debug;
  $p = rmTaint($p);
  rename($p, $expired_keys_directory.$p) if !$debug;
 }
}


#-------------------------------------#


print "Starting to parse zone file..\n" if $debug;
while(defined($l=<ZONE_FILE>)){
 # increment zone serial
 if($l=~/^@\s+in\s+SOA\s+/i){
  #change_zone 0;
  print TEMP_ZONE_FILE $l;
  $l=<ZONE_FILE>;
  my ($hour,$mday,$mon,$year) = (localtime(time))[2..5];
  my $serial=($year+1900).($mon+1>9?'':'0').($mon+1).($mday>9?'':'0').$mday.($hour>9?'':'0').$hour;
  $l=~s/\d+/$serial/;
  print "Change serial to $serial\n" if $debug;
  #print TEMP_ZONE_FILE $l;
  #next;

 }elsif($l=~/^;\s*([ZK]SK)/){
  change_zone $1;

 }elsif($in_zone){
  if($l=~/^\$include\s+(.+)$/){
   if($in_zone eq 'ZSK' && index($1,$rolling_key) != -1){
    $include_pattern = $l;
    print "Comment out old ZSK [$1].\n" if $debug;
    $l = ';expired '.Now()."\n;".$l;
    move_expired($rolling_key);

   }elsif($in_zone eq 'KSK' && !$KSK_file){
    $include_pattern = $l if !$include_pattern;
    # determine what is KSK.
    my $f = $1;
    $f=~/([^\/]+)$/;
    $f = $1;
    print 'KSK file: [', $KSK_file?$KSK_file.'] -> [':'', $f, "]\n" if $debug;
    $KSK_file = $f if -f $keys_directory.$f;
   }

  }elsif($l!~/^\s*;/){# && $l!~/^\s*$/
   change_zone 0;
  }
 }

 print TEMP_ZONE_FILE $l;
}

close TEMP_ZONE_FILE;
close ZONE_FILE;

rename $unsigned_zone_file, $unsigned_zone_file.'.bak' if !$debug;
rename $temporary_unsigned_zone_file, $unsigned_zone_file if !$debug;


# -N increment automatically increments the serial number during signing. Removes human error factor
my $cmd = rmTaint $program_directory."dnssec-signzone -N increment -o '$domain' -k '$KSK_file' '$unsigned_zone_file' '${key_string}.key'";
print "$cmd\n" if $debug;
`$cmd` if !$debug;

# copy config files & restart namedb daemon
`/bin/cp -prif /etc/namedb /var/named/etc/ && ${program_directory}named-checkconf && ${program_directory}rndc reload` if !$debug;

print "\n** It's done.\nPlease login https://dlv.isc.org/ to check if the configuration is working.\n";

